<p>Nakon uvodne priče, došlo je vrijeme da pogledamo kako napisati arhitekturu kod strukturnog modela.</p>

<p>Struktura naredbe kojom se u arhitekturu sklopa dodaje primjerak neke komponente prikazana je u nastavku.<br>
<em>nazivPrimjerkaKomponente</em> <code>:</code><br> 
&nbsp;&nbsp;&nbsp;&nbsp;<code>ENTITY</code> <em>nazivBiblioteke.imeSklopa</em><br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>PORT</code> <code>MAP</code> <code>(</code> <em>specifikacija povezivanja portova komponente</em> 
<code>)</code> <code>;</code>
</p>

<p>Pri strukturnom modeliranju očekuje se da su komponente koje ćemo koristiti već napisane i da su dostupne u trenutnom 
   projektu. Komponente koje mi pišemo automatski se smještaju u biblioteku imena <code>work</code> (bez da to moramo
   igdje posebno specificirati). Stoga ćemo u naredbi za stvaranje primjerka komponente nakon ključne riječi <code>ENTITY</code>
   uvijek pisati imena oblika <em>work.imeSklopaX</em> gdje je <em>imeSklopaX</em> naziv sklopa čije smo sučelje
   i arhitekturu već prethodno napisali i koji sada želimo koristiti kao gotovu komponentu.
</p>

<p>Pri <em>pozicijskom povezivanju</em>, unutar oblih zagrada koje dolaze nakon ključnih riječi <code>PORT</code>
   <code>MAP</code> navode se imena signala iz modeliranog sklopa koja se dovode na portove sklopa čiji primjerak
   stvaramo ovom naredbom. Pri tome se očekuje da se na prvo mjesto specificira koji se signal dovodi na port
   koji je prvi specificiran u sklopu čiji primjerak stvaramo, i tako redom. Signali se međusobno odvajaju znakom
   zareza.
</p>

<p>Pogledajmo to na našem radnom primjeru. Shema sklopa <em>sklop3</em> ponovno je prikazana na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(sklop3c.svg)" alt="Shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Konačna dopunjena shema sklopa <em>sklop3</em>.</figcaption>
</figure>

<p>Najprije ćemo napisati naredbu kojom ćemo u arhitekturi sklopa <em>sklop3</em> definirati da imamo komponentu
   <em>c1</em> koja je primjerak sklopa <em>sklop1</em>. Da bismo to mogli, podsjetimo se: pretpostavili smo da u
   projektu u kojem ovo radimo već imamo napisanu VHDL-specifikaciju sklopa <em>sklop1</em> i da je u njoj sučelje
   tog sklopa bilo definirano na sljedeći način.</p>
<pre><code>ENTITY sklop1 IS PORT (
  a: IN std_logic;
  b: IN std_logic;
  c: IN std_logic;
  f: OUT std_logic
);
END sklop1;</code></pre>

<p>Naredba kojom ćemo u arhitekturi sklopa <em>sklop3</em> definirati da imamo komponentu
   <em>c1</em> koja je primjerak sklopa <em>sklop1</em> tada će biti oblika:</p>
<pre><code>c1: ENTITY work.sklop1 PORT MAP ( ... );</code></pre>
<p>Na mjestu gdje smo stavili tri točkice trebamo napisati pozicijsko povezivanje ove komponente. Idemo redom.
   Stvaramo primjerak sklopa <em>sklop1</em>.</p>
<ol>
<li>Pogledajte u sučelje sklopa <em>sklop1</em>: prvi port koji je u njemu definiran je <code>a</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj ulaz <code>a</code>? Odgovor je: ulaz <code>a</code> sklopa <em>sklop3</em>. Stoga u zagrade
    najprije pišemo taj ulaz:<br>
    <code>(a ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop1</em>: drugi port koji je u njemu definiran je <code>b</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj ulaz <code>b</code>? Odgovor je: ulaz <code>x</code> sklopa <em>sklop3</em>. Stoga u zagrade
    razdvojeno znakom zarez na drugo mjesto stavljamo taj ulaz:<br>
    <code>(a, x ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop1</em>: treći port koji je u njemu definiran je <code>c</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj ulaz <code>c</code>? Odgovor je: ulaz <code>y</code> sklopa <em>sklop3</em>. Stoga u zagrade
    razdvojeno znakom zarez na treće mjesto stavljamo taj ulaz:<br>
    <code>(a, x, y ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop1</em>: četvrti port koji je u njemu definiran je <code>f</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj izlaz <code>f</code>? Odgovor je: interni signal <code>s</code> sklopa <em>sklop3</em>. Stoga 
    u zagrade razdvojeno znakom zarez na drugo mjesto stavljamo taj interni signal:<br>
    <code>(a, x, y, s)</code><br>
    čime je popis signala kompletan jer smo prošli kroz sve portove definirane u sučelju sklopa 
    <em>sklop1</em>.</li>
</ol>
<p>Čitava naredba tada glasi:</p>
<pre><code>c1: ENTITY work.sklop1 PORT MAP (a, x, y, s);</code></pre>
<p>Naziv <em>pozicijsko povezivanje</em> proizlazi iz činjenice da kod ovog načina "spajanja" komponente
   nigdje eksplicitno ne imenujemo imena portova povezivane komponente; umjesto toga, očekujemo da će prvi
   signal koji napišemo biti spojen na prvo-definirani port u sučelju povezivane komponente, drugi signal na
   drugo-definirani port i tako redom. Pozicija na kojoj smo u popisu napisali ime signala određuje na koji
   će port taj signal biti spojen.</p>

<p>Ostalo nam je napisati naredbu kojom ćemo u arhitekturi sklopa <em>sklop3</em> definirati da imamo komponentu
   <em>c2</em> koja je primjerak sklopa <em>sklop2</em>. Ta će naredba biti oblika:</p>
<pre><code>c2: ENTITY work.sklop2 PORT MAP ( ... );</code></pre>
<p>Da bismo dovršili naredbu, morat ćemo se prisjetiti kako je izgledalo sučelje
   sklopa <em>sklop2</em>. To je sučelje ponovljeno u nastavku.</p>
<pre><code>ENTITY sklop2 IS PORT (
  a: IN std_logic;
  b: IN std_logic;
  f: OUT std_logic
);
END sklop2;</code></pre>

<p>Idemo odrediti što ćemo pisati u oblim zagradama.</p>
<ol>
<li>Pogledajte u sučelje sklopa <em>sklop2</em>: prvi port koji je u njemu definiran je <code>a</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj ulaz <code>a</code>? Odgovor je: interni signal <code>s</code> sklopa <em>sklop3</em>. 
    Stoga u zagrade najprije pišemo taj interni signal:<br>
    <code>(s ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop2</em>: drugi port koji je u njemu definiran je <code>b</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj ulaz <code>b</code>? Odgovor je: ulaz <code>a</code> sklopa <em>sklop3</em>. Stoga u zagrade
    razdvojeno znakom zarez na drugo mjesto stavljamo taj ulaz:<br>
    <code>(s, a ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop2</em>: treći port koji je u njemu definiran je <code>f</code>.
    Pogledajte shemu na slici 1: koji se ulaz / izlaz / interni signal sklopa <em>sklop3</em> dovodi
    na taj izlaz <code>f</code>? Odgovor je: izlaz <code>g</code> sklopa <em>sklop3</em>. Stoga u zagrade
    razdvojeno znakom zarez na treće mjesto stavljamo taj izlaz:<br>
    <code>(s, a, g)</code><br>
    čime je popis signala kompletan jer smo prošli kroz sve portove definirane u sučelju sklopa 
    <em>sklop2</em>.</li>
</ol>
<p>Čitava naredba tada glasi:</p>
<pre><code>c2: ENTITY work.sklop2 PORT MAP (s, a, g);</code></pre>

<p>Čitav strukturni model sklopa <em>sklop3</em> prikazan je u nastavku.</p>

<pre><code>library ieee;
use ieee.std_logic_1164.all;

ENTITY sklop3 IS PORT (
  a: IN std_logic;
  x: IN std_logic;
  y: IN std_logic;
  f: OUT std_logic;
  g: OUT std_logic
);
END sklop3;

ARCHITECTURE str OF sklop3 IS
  SIGNAL s: std_logic;
BEGIN

  c1: ENTITY work.sklop1 PORT MAP (a, x, y, s);
  c2: ENTITY work.sklop2 PORT MAP (s, a, g);

  f &lt;= s;

END str;</code></pre>

<p>Primijetite: u deklaracijskom dijelu arhitekture definirali smo interni signal <code>s</code> koji smo
   obilježili na shemi. U tijelo arhitekture dodali smo tri naredbe.</p>
<ol>
<li>Prva naredba stvara primjerak imena <em>c1</em> sklopa <em>sklop1</em>, i ona efektivno definira koja se
    vrijednost upisuje u interni signal <code>s</code> sklopa <em>sklop3</em> (uočite da je on spojen na izlazni port sklopa <em>sklop1</em>).</li>
<li>Druga naredba stvara primjerak imena <em>c2</em> sklopa <em>sklop2</em>, i ona efektivno definira koja se
    vrijednost upisuje na izlaz <code>g</code> sklopa <em>sklop3</em> (uočite da je on spojen na izlazni port sklopa <em>sklop2</em>).</li>
<li>Prethodne dvije naredbe nisu definirale što se zapisuje na izlaz <code>f</code> sklopa <em>sklop3</em>: stoga
    treća naredba definira da se vrijednost koja je postavljena na interni signal <code>s</code> zapisuje i na
    izlaz <code>f</code> sklopa <em>sklop3</em>.</li>
</ol>

<p>Redoslijed naredbi koje smo napisali u tijelu arhitekture nema nikakvog utjecaja na korektnost napisanog
   opisa. Podsjetimo: sve se naredbe u tijelu arhitekture izvode istovremeno.</p>

<p>Ovime smo završili pregled pozicijskog povezivanja komponenata kod izrade strukturnog modela.</p>


